// switches
var debugging = true;       // switch on debug display  Enables TraceMsg()

// INTERNATIONALISATION ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Note that the PHP code should be be synchronised as it also needs modifications
var en_actionNotApplicable  = 'Action not applicable to this element';
var en_aOverwriteWarning    = 'WARNING\nNo upload file specifed.\nOK to use existing or CANCEL to quit';
var en_cancelled            = 'Cancelled';
var en_confirmSave          = 'Changes made!\nDo you want to save them?'; 
var en_dontForgetToSave     = '\nDo not forget to save document';
var en_itemWillBeHidden     = 'You can\'t delete the only copy of this item.\n'
                            + 'It will be hidden instead.\n\n'
                            + 'Hidden items don\'t appear in the actual web page\n'
                            + 'but are shown here and can be brought back to life\n'
                            + 'simply by editing them.';
var en_noFileSpecified      = 'No upload file specifed.';
var en_savingUploadChanges  = 'Saving upload changes';
var en_setPassword          = 'Please set password before editing';
var en_shortText            = 'Failed: Display text is too short.';
var en_textWillBeHidden     = 'This cannot be completely deleted.\n'
                            + 'But it will be hidden on the finished page.\n';
var en_okToDelete           = 'OK to delete this';
var en_block                = 'block';               // for okToDelete  
var en_listItem             = 'item from the list';  // for okToDelete
var en_tableRow             = 'row from the table';  // for okToDelete
var en_fail                 = 'FAIL';  // MUST be synchronised with PHP                            
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


// constants
var ACTION_NONE = 0;        // text may contain commands to
var ACTION_DELETE = 1;      // perform whole block actions
var ACTION_ADDABOVE = 2;    // These are the integer actions
var ACTION_ADDBELOW = 3;    // as decoded by GetAction()

$.fn.tagName = function() {return this.get(0).tagName;}  // we do a lot of getting of tags

//
function CentraliseForm(Form){
// Centralise the upload forms
//
  var winh = $(window).height();
  var winw = $(window).width();
  var fw = Form.width();  // should be 450
  var fh = Form.height(); 
  var topMargin = ((winh - Form.height())/2)-40;   
  var leftMargin = ((winw - Form.width())/2)-10;
  var ms = topMargin.toString() + 'px ' + leftMargin.toString() + 'px';
  Form.css('margin',ms);
}

//
function SanitizeInput(RawInput,MaxLength){
// Strip silly/risky characters and trim
// If necessary chop down to max length
//
  var s = RawInput.replace('<','');
  s = s.replace('>','');
  s = s.replace('"','');
  s = jQuery.trim(s);
  return s.substring(0,MaxLength-1);
}  

//
function TraceMsg(Msg){
// debugging aid
//
  if(debugging){
    var debugs = $('div#debugs')
    debugs.show();
    var t = debugs.text() + '| ' + Msg;
    debugs.text(t);
  }  
}

//
// Global variables
//
var needsSaving = false;     // set true by AJAX OK (A-tag and IMG uploads)
var textChanged = false;     // set true by other editing actions
var workingElement = null;   // what we're editing
var disabledFamily = null;   // parents (and possibly children) we may have made uneditable for a while
var textWrappedFlag = false; // have we wrapped text nodes in divs for editing purposes?
var activeElement = null;    // editable element that was clicked upon 
                             // (may not be the same one that gets focus)
var atag = null;             // what A element are we uploading
var img  = null;             // what img are we uploading
var isIE = false;            // Is it being rendered in IE (gloom!)


//
function DisableFamily(Elmt){
// We may be editing the bits of a DIV sub-elements.  These sub-elements may
// be 'proper' elements such as <span> or <h2> say, or textNodes.  The problem
// is that we can't allow the textNodes and sub-elements to be edited in one
// big melting pot otherwise we can easily end up trashing the content by
// breaking into one element from another - horrible!
// So when we get a DIV with any 'proper' children we have to take precautions
// and disable all the children, the parent and also isolate the textNodes
// which we do by wrapping them in temporary divs.
// We keep a list of these messed-about elements in a global disabledFamily.
// We'll also set a global flag textWrappedFlag to tell if we need to undo
// the temporary DIV wrappings
//
  var pels = Elmt.parents('.ed,.edx');  // editable parents
  var cels = Elmt.children();           // any children 
  var nump = pels.length;
  var numc = cels.length;
  disabledFamily = null;
  textWrappedFlag = false;
  if((nump==0)&&(numc==0)){return;}     // nothing to do  this is a standalone element 
  
  // disable other members of the family
  disabledFamily = pels.add(cels);               // always disable rest of family
  if(numc>0){disabledFamily = disabledFamily.add(Elmt);}          // if has children then disable self...
  disabledFamily.each(function(){
    $(this).removeAttr('contentEditable').addClass('greyedOut');  // ...(! yes we'll enable the text nodes separately)
  });
  // if there are children then we need to make the text nodes editable as temporary divs in their own right
  var tnodes = Elmt.contents().filter(function(){ return(this.nodeType == 3); });
  tnodes.wrap('<div class=textNodeEdit contentEditable=true>');
  // we want to focus on the first div=contenteditable
  var firstEdit = Elmt.children('[contentEditable]').filter(':first');
  firstEdit.focus();
  textWrappedFlag = true;
}

//
function EnableFamily(){
// We may have disabled close relatives of the item being edited
// (in DisableFamily()) We want to reverse this.  One of the important
// tasks is unwrapping the DIVs from textNodes
//
  if(disabledFamily != null){
    disabledFamily.each(function(){
      $(this).attr('contentEditable');
      $(this).removeClass('greyedOut');  
    });
  }
  if(textWrappedFlag == true){
    textWrappedFlag = false;
    var divs = $('div.textNodeEdit');   // [@] operate on active element 
    divs.each(function(){
      var tx = $(this).text();
      $(this).replaceWith(tx);
    });  
  }  
}
  
//
function StartElementEdit(Element){
// Make a note of which element
// If applicable show command buttons
// Cell editing needs to reference the whole row
// Possibly convert hidden (edx) into normal (ed) 
// Possibly call the disabling of family elements

  // make sure we've finished anything we were working on
  if(workingElement != null){FinishElementEdit();};

  var tag  = Element.tagName();   // type of element       LI DIV SPAN TD A IMG H1 H2 H3 H4
  //TraceMsg('START EL='+tag + ' AE='+activeElement.tagName());
  
  // possibly an edx (hidden) element If so make it live.
  if(Element.hasClass('edx')){
    Element.addClass('ed');
    Element.removeClass('edx');
  }
  
  // cell editing triggers the whole row
  if(tag=='TD'){
    var tr = Element.parent();
    tr.children('TD').addClass('ed').removeClass('edx');
    tr.addClass('ed').removeClass('edx');
  }else{
    DisableFamily(Element);   // we may be mixed up with siblings or childre or parents!
  }  

  // Debugging tool var ce = $('[contenteditable]');;  ce.each(function(){TraceMsg('CE='+$(this).tagName());});
  // Debugging tool Element.keyup(function(){TraceMsg('u');});
  
  // Save globally  NB turned to null by FinishElementEdit()
  workingElement = Element;   

  // do we show the add and delete buttons
  switch(tag){   
  case 'TD' :  
  case 'LI' :
  case 'DIV' :
    $('a.menuButton').show();
    break;      
  default:
    $('a.menuButton').hide();
  };
  return false;
}
  

//
function FinishElementEdit(){
// Lots of tying up of loose ends
// If a Hn, LI, SPAN or DIV is edited to be blank then we try to convert it to hidden
//
  textChanged = true;  // Used if leaving screen without saving changes
  var t = workingElement.text(); 
  var tag  = workingElement.tagName();   // type of element       LI DIV SPAN TD
  //TraceMsg('FINISH='+tag);
  if(jQuery.trim(t)==''){    // OH DEAR!  We are trying to leave an empty item.
                             // this is what we came here to stop
    switch(tag){   
    case 'SPAN':   // these are pure text that are not part of   
    case 'H1' :    // any list.  Hide them
    case 'H2' :
    case 'H3' :
    case 'H4' :
      workingElement.text('hidden');
      workingElement.addClass('edx').removeClass('ed');
      alert(en_textWillBeHidden)
      break;
    case 'LI' :
    case 'DIV' :
      workingElement.text('hidden');
      DoCommand(ACTION_DELETE);
      break;      
    default:
      ;// nothing special to do  
    };
  } // not empty   

  // we may have disabled the parent if nesting something inside a div  
  EnableFamily();
  workingElement.children().removeClass('greyedOut');  
  workingElement.removeClass('greyedOut');  
  workingElement = null;
};  

    
    
//
function DoCommand(Action){
// ADD, DELETE etc.
// The first step is to decide what we're looking at/working with so we can
// identify the 'row element' to manipulate.
// Secondly delete (but not the last item in a list! - hide instead) or clone.
//
  textChanged = true;  // Used if leaving screen without saving changes
  var tag  = workingElement.tagName();   // type of element       LI DIV SPAN TD
  
  // Find the 'row element' which may be self or TR parent to TD
  var rowElement=null;
  switch(tag){
  case 'DIV':
    rowElement = workingElement;     // disable this if divs can't be cloned/deleted
    var ri = en_block;
    break;
  case 'LI':                         // list items are manipulated in their own right
    rowElement = workingElement;
    var ri = en_listItem;
    break;
  case 'TD':                         // td elements have to be manipulated as a row
    rowElement = workingElement.parent();
    var ri = en_tableRow;
    break;
  default:
    alert(en_actionNotApplicable);  // can never happen
  };        
  if(rowElement==null){          // we may not have anything to work with(!) so quit
    return false;
  };    
    
  // make sure we finish off any editing we may be in the middle of
  EnableFamily();
  workingElement.children().removeClass('greyedOut');  
  workingElement.removeClass('greyedOut');  
    
  // at this point we have elmt original and rowElement the item to be acted upon (may be the same)
  if(Action==ACTION_DELETE){
    // we want to be careful about deleting items with no siblings
    // instead we hide them by changing the .ed to .edx
    var rowTag  = rowElement.tagName();   // type of element OF ROW
    var noSibs = $(rowElement).siblings(rowTag + '.ed').size();
    if(noSibs<1){
      rowElement.addClass('edx').removeClass('ed');
      // special case for table rows we need to hack the cells as well
      if(rowTag=='TR'){
        rowElement.children('TD').addClass('edx').removeClass('ed');
      }  
      alert(en_itemWillBeHidden);
    }else{
      if(confirm(en_okToDelete+' '+ri)){
        rowElement.remove();
      }  
    }  
    //alert('element deleted');
    return false;
  };
  
  // cloning before or after.  If the element being cloned contains
  // items (other than cells) that are editable in their own right
  // then clone completely.  Otherwise wipe contents.
  var c = rowElement.clone(true,true);  // do clone
  var noInnerBits=rowElement.find('.ed,.edx').filter(':not(td)').size();
  if(noInnerBits==0){
    switch(tag){
    case 'DIV':
      c.text('new');                   // We need something to start with for a new div
      break;
    case 'LI':                     
      c.text('new');                   // We need something to start with for a new LI
      break;
    case 'TD':                         // td elements have to be manipulated as a row
      c.children('td').text('');             // its the _cells_ that need clearing
      c.children(':first(td)').text('new');  // but we need one with something in to give it size
      break;
    };        
  }
  
  switch(Action){
  case ACTION_ADDABOVE: 
    rowElement.before(c);
    break;
  case ACTION_ADDBELOW: 
    rowElement.after(c);
    break;
  }
  
  return false;
}

//
function ClearPwStripe(){
// Very annoying stripe on password
// remove at slightest opportunity
//
  var pw=$('input#pw');
  if($.trim(pw.val())!=''){
    pw.css('background-image','none');
  }  
}; 
      

  

//
function candyEdit(pageName){
// MAIN   ENTRY
// This goes in the onReady() block and is where everything is setup.
// Initialisation
//  Add the contentEditable attribute to text-ish places 
//  Add the button to images
//  Jiggle with the A-tags to save the title out of harms way
// Set up event hooks
//  Save/unload
//  Button clicks, help show/hide
//  Handle AJAX responses
//  Catch start and finish editing an element
//  Start image upload
//  Start A-tag upload
//

  // Browser detection.  IE is hopeless with tables
  isIE = ($.browser.msie == true);
  

  // ====================================  
  // SETUP MARKUP ETC ON READY
  // ====================================  
  // The "ed" class is what we use to indicate editable.
  // ---------------------------------------------------------------------------------------------------
  // all items except tr marked with class=ed become editable
  //$('.ed,.edx').filter(':not(tr,img,a)').attr('contentEditable', true);     // text
  $('.ed,.edx').filter('div,span,h1,h2,h3,h4,li').attr('contentEditable', true);     // text
  $('.ed,.edx').filter('tr').children('td').attr('contentEditable', true);  
  
  // We need to play with each image to associate a button with it     // image
  // wrap everything span(original image - button - upload input)
  $('img.ed').each(function() {
    var butimg = '<img src="candyButton.jpg" class=butImg >';   
    var wrapper = $('<span class=imgWrapper></span>');
    $(this).wrap(wrapper).after(butimg);
  }); 
  
  // links will be uploaded files eg say pdf of last month's minutes.
  $('a.ed').each(function(){
    var a = $(this);  
    var h = a.attr('href');
    var t = a.attr('title');                    // save any title as a bit of data
    if(t != ''){a.data('savedTitle',t);}        // for the time being 
    a.attr('title',h);
  });  
  
  // disable fancy table editing UI in Firefox
  try{document.execCommand("enableInlineTableEditing", false, false);}catch(err){;}  // IE doesn't like this
  
  
  $('input#pw').focus();   // put the input focus on the password to get that out of the way
  $('input#pw').focus(function(){ClearPwStripe();});
  $('input#pw').keyup(function(){ClearPwStripe();});
  $('input#pw').blur(function(){ClearPwStripe();});
  
  // ##### We want to trap forgetting to save before leaving the page##############################
  // ##### there are circumstances when we want to automatically trigger a save:-##################
  // ##### 1 - MUST save if A-Tag or IMG uploads have been successful##############################
  // ##### 2 - POSSIBLY save if text edits made####################################################
  // ##### To monitor these conditions we have two globals#########################################
  // #####   needsSaving - set true by AJAX OK #################################################### 
  // #####   textChanged - set true by other actions###############################################
  if(debugging==false){                                                       // don't if debugging
    $(window).unload(function() {
      if(needsSaving==true){
        alert(en_SavingUploadChanges);
        $('#save').click();
      }else{
        if(textChanged==true){
          if(confirm(en_confirmSave)){
            $('#save').click();
          }
        }
      }      
    });
  }
  
  
  // command button hooks
  $('#buDelete').click(function(){return DoCommand(ACTION_DELETE);});  
  $('#buAddAfter').click(function(){return DoCommand(ACTION_ADDBELOW);});  
  $('#buAddBefore').click(function(){return DoCommand(ACTION_ADDABOVE);});  
  $('#help').click(function(){$('#helpPanel').slideDown(500);});  
  $('#helpCancel').click(function(){$('#helpPanel').slideUp(500);});  

  // when iframe gets loaded we can process the result (IMG or A-TAG)
  $('#uframe').load(function(){  
    var iframeBody = $(this)[0].contentDocument.body.innerHTML;
    var ok = (iframeBody.indexOf('OK') == 0);
    if(ok != true){
      // We haven't got a good result but we may be getting a weird result
      // The result /should/ start with FAIL in which case we know that it
      // is some normal problem.  But it may not, and be an odd message
      // from the server
      var fail = (iframeBody.indexOf(en_fail) == 0);
      if(fail==false){
        // The known possible case is where an oversized uploat has upset the server
        // before the candyedit.php program has got a chance to look at it.  Handle this
        // particular case gracefully or spout something generic.  
        var errMsg = iframeBody.substring(0,250);           // tidy up the error message
        var i = errMsg.toLowerCase().indexOf('<html>');       // it may well have the whole editing stuff
        if(i>-1){errMsg = errMsg.substring(0,i);}           // sent along with it!
        if(errMsg.indexOf(' POST ')>-1){
          errMsg = 'FAIL Uploaded file is too big.\nPhotographs should be cropped and resized';            //i18n
        }else{  
          errMsg = 'EXCEPTIONAL ERROR - Your technical support may find the following useful\n' + errMsg;  //i18n
        }  
        alert(errMsg);
      }else{  
        alert(iframeBody);      // error and quit
      }
    }else{
      if(atag != null){       // a-tag processing  USE ANOTHER METHOD
        var tx = SanitizeInput($('#aText').val(),60);     // get the data
        var ti = SanitizeInput($('#aTitle').val(),160);   // and remove risky characters
        var fi = SanitizeInput($('#aFile').val(),160);    
        atag.data('savedTitle',ti);    // this will get transferred to title at SAVE time
        atag.text(tx);                 // link text
        atag.attr('href',fi);          // NOTE All uploads go into 'home' dir ie *NO PATH*
        atag = null;
      }
      if(img != null){        // img processing
        var ti = SanitizeInput($('#iTitle').val(),160);   // and remove risky characters
        var fi = SanitizeInput($('#iFile').val(),160);    
        img.attr('title',ti);   
        img.attr('src',fi);   
      }  
      alert(iframeBody + en_dontForgetToSave);
      needsSaving = true;
    }
    // housekeeping regardless of OK/FAIL
    if(img != null){        // img processing
      img.next().show();    //re-show button
      img = null;
    }
    if(atag != null){       // a-tag processing  USE ANOTHER METHOD
      atag = null;
    }         
  });  // end of iframe.load()

  
  // ================================================================    
  // EDITING EVENTS
  // ================================================================  
  // Prevent CRs being typed into list items and headings
  $('LI[contentEditable],H1[contentEditable],H2[contentEditable],H3[contentEditable],H4[contentEditable]').keypress(function(event){
      return event.which != 13;
  });

  // Start editing an item event hooks
  // ---------------------------------------------------------------------------------------------------
  // NB we don't use focus and blur for complicated reasons
  // This gets us started and we'll finish when we start the next thing or save
  $('[contentEditable]').mousedown(function(e){   // we may be editing an item within an item
    activeElement = $(e.target);                  // If we've specifically clicked on it then
    StartElementEdit(activeElement);              // set by mousedown()  This means we get at the actual
    e.stopPropagation();
  });                                             // we want to edit this not the parent!  
  
  
                                                   
  // ====================================================
  // Finished editing page - save
  // ====================================================
  $('#save').click(function(){
    if(workingElement != null){FinishElementEdit();};
    needsSaving = false;
    textChanged = false;
    var pw = $('#pw').val();
    if(jQuery.trim(pw)==''){
      alert(en_setPassword);
    }else{  
      $('div.imgUpload').remove();    // always remove hanging upload dialogs
      $('div.aEdit').remove();      

      // remove any image wrapping/buttons
      $('img.ed').next().remove();          // get rid of buttons
      $('img.ed').unwrap();                 // remove enclosing span
      // restore the title attribute to a tags before finishing 
      $('a.ed').each(function(){
        var a = $(this);  
        var t = a.data('savedTitle');      
        if(t != ''){a.attr('title',t);}     
        a.show();
      });  

      // replace < and > in text elements with html entities      
      var textnodes = $('body *').filter(function(){ return(this.nodeType == 3); });
      TraceMsg('TEXTNODES='+textnodes.size());  //@@@
      textnodes.each(function(){
        var t = $(this).html();
        var t1 = t.replace(/</,'&lt;');
        var t2 = t1.replace(/>/,'&gt;');
        $(this).html(t2);
        if(t != t2){TraceMsg('REPLACED:'+t2);}  //@@@
      });  

      
      // extract the body
      var newValue = $('body').html();
      var nvNoAmp  = encodeURIComponent(newValue);     // we need to get rid of any &s and possibly other special characters
      // build array of parameters for ajax request        
      var params = {};
          params['type']= 'POST';
          params['url'] = 'candyedit.php?page='+pageName;    
          params['data']= 'newBody='+nvNoAmp+'&pw='+pw;
          params['success']= function(msg){
                               alert(msg);
                               window.location.href = pageName;
                             };
       $.ajax(params);
    }//pw present   
  });// save hook
  
  // ====================================  
  // IMAGE UPLOADING
  // ====================================  
  $('.butImg').click(function(){
    if(workingElement != null){FinishElementEdit();};
    atag=null;                                         // uframe processing switch
    var pw = $('#pw').val();                           // need the password
    if(jQuery.trim(pw)==''){                           // very basic validation
      alert(en_setPassword);
      return false;
    }  
    var but = $(this);
    img = but.prev();                    // img is global
    var src = img.attr('src');           // source will be used to identify the original file
    var ti  = img.attr('title');

    but.hide();                          // don't need showing this for now
    DisableFamily(img);
    // fill in important bits of the form
    $('#iForm').attr('action','candyedit.php?page=' + pageName);
    $('#iPw').val(pw);
    $('#iSrc').val(src);
    $('#iTitle').val(ti);
    // and display it as a dialog
    CentraliseForm($('#iForm'));
    $('div#idiv').show();
    
    // cancel button simply removes the edit form div and shows all a.eds
    $('#iCanx').click(function(){
      $('div#idiv').hide();
      but.show();
      EnableFamily();
    });

    // now trap finished picking file
    $('#iSave').click(function(){
      var ti = SanitizeInput($('#iTitle').val(),160);   // remove risky characters
      //@@@ deal with double quoted embedded 
      var fi = SanitizeInput($('#iFile').val(),160);    

      $('div#idiv').hide();
      if(fi.length < 1){
        alert(en_noFileSpecified);
      }else{  
        $('#iForm').submit();
      }// not a validation error
      EnableFamily();
      return false;
    });  
    return false;
  });//img editing

  // ====================================  
  // A TAG EDITING
  // ====================================  
  $('a.ed').click(function(){
    if(workingElement != null){FinishElementEdit();};
    img = null;                       // uframe processing switch 
    $('div.aEdit').remove();          // avoid multiples and hanging half-complete 
    $('a.ed').show();                 // previous attempts
    var a = $(this); 
    atag = a;
    DisableFamily(a);
    var hr = a.attr('href');          // href
    var ti = a.data('savedTitle');    // the title=hint we saved earlier
    var tx = a.text();                // link text
    var pw = $('#pw').val();          // need the password
    if(jQuery.trim(pw)==''){                           // very basic validation
      alert(en_setPassword);
      return false;
    }  
    // fill in important bits of the form
    $('#aForm').attr('action','candyedit.php?page=' + pageName);
    $('#aPw').val(pw);
    $('#aText').val(tx);
    $('#aTitle').val(ti);
    // and display it as a dialog
    CentraliseForm($('#aForm'));
    $('div#adiv').show();
    a.hide();
    
    // cancel button simply removes the edit form div and shows all a.eds
    $('#aCanx').click(function(){
      $('div#adiv').hide();
      $('a.ed').show();
      EnableFamily();
    });
    
    $('#aSave').click(function(){
      var tx = SanitizeInput($('#aText').val(),60);     // get the data
      var ti = SanitizeInput($('#aTitle').val(),160);   // and remove risky characters
      var fi = SanitizeInput($('#aFile').val(),160);    
      // validation
      var error = '';
      if(tx.length < 2){
        error = en_shortText;
      }else{
        if(fi.length < 1){
          var ok = confirm(en_aOverwriteWarning);
          if(ok != true){error = en_cancelled;}
        }
      }
      $('div#adiv').hide();
      $('a.ed').show();
      EnableFamily();
      if(error != ''){
        alert(error);
      }else{  
        $('#aForm').submit();
      }
    });
    return false;  
  });  
};    
